/*
   They are used in the following program.  Usage:
   blockinfo /dev/hda2 /dev/hda4 /dev/hda8 ...

   The HDIO_GETGEO ioctl allows to get the start of a partition, and the
   BLKGETSIZE gets the size.
 */

#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <linux/fs.h>
#include <linux/hdreg.h>
#include <unistd.h>
#include <stdlib.h>

int main (int argc, char **argv)
{
	struct hd_geometry loc;
	int fd, size, i;

	for (i = 1; i < argc; i++) {
		fd = open (argv[i], O_RDONLY);
		if (fd < 0) {
			perror ("open");
			exit (1);
		}
		if (ioctl (fd, HDIO_GETGEO, &loc) < 0) {
			perror ("ioctl start");
			exit (1);
		}
		if (ioctl (fd, BLKGETSIZE, &size) < 0) {
			perror ("ioctl start");
			exit (1);
		}
		printf ("%s: h=%3d s=%3d c=%4d   start=%8d size=%8d end=%8d\n",
			argv[i], loc.heads, (int) loc.sectors, loc.cylinders,
			(int) loc.start, size, (int) loc.start + size - 1);
		close (fd);
	}
	exit (0);
}
